#!perl -w

require 5;

use strict;
use vars qw/$pattern/;

# Read the database in paragraph mode.
$/ = '';

$pattern = shift;

open (DATABASE, "cajindex.txt") || die "can't open cajindex.txt: $!";
while (<DATABASE>) {
    my $orig = $_;
    # merge continuation lines
    s/\n\s+/ /g;
    my @fields = split ("\n");
    foreach (@fields) {
        my ($name, $value) = split (": ", $_, 2);
        # Ignore certain fields
        next if $name eq 'Issue';
        next if $name eq 'Section';
        next if $name eq 'HTML';
        next if $name eq 'PDF';
        # If the pattern occurs in the value, print the entire entry.
        if ($value =~ /$pattern/i) {
            print $orig;
            last;
        }
    }
}

close DATABASE;
